<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="批次id" prop="batchId">
        <el-input
          v-model="queryParams.batchId"
          placeholder="请输入批次id"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="学生id" prop="studentId">
        <el-input
          v-model="queryParams.studentId"
          placeholder="请输入学生id"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="定向标识学生可能有多个" prop="directKey">
        <el-input
          v-model="queryParams.directKey"
          placeholder="请输入定向标识学生可能有多个"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="批次卷id" prop="paperId">
        <el-input
          v-model="queryParams.paperId"
          placeholder="请输入批次卷id"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="学生班级" prop="classId">
        <el-input
          v-model="queryParams.classId"
          placeholder="请输入学生班级"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="考卷ID" prop="examineeId">
        <el-input
          v-model="queryParams.examineeId"
          placeholder="请输入考卷ID"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['learn:test_student:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['learn:test_student:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['learn:test_student:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['learn:test_student:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="test_studentList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="批次学生id" align="center" prop="id" />
      <el-table-column label="批次id" align="center" prop="batchId" />
      <el-table-column label="学生id" align="center" prop="studentId" />
      <el-table-column label="定向标识学生可能有多个" align="center" prop="directKey" />
      <el-table-column label="批次卷id" align="center" prop="paperId" />
      <el-table-column label="学生班级" align="center" prop="classId" />
      <el-table-column label="考卷ID" align="center" prop="examineeId" />
      <el-table-column label="状态" align="center" prop="status" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['learn:test_student:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['learn:test_student:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改测试学生对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="test_studentRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="批次id" prop="batchId">
          <el-input v-model="form.batchId" placeholder="请输入批次id" />
        </el-form-item>
        <el-form-item label="学生id" prop="studentId">
          <el-input v-model="form.studentId" placeholder="请输入学生id" />
        </el-form-item>
        <el-form-item label="定向标识学生可能有多个" prop="directKey">
          <el-input v-model="form.directKey" placeholder="请输入定向标识学生可能有多个" />
        </el-form-item>
        <el-form-item label="批次卷id" prop="paperId">
          <el-input v-model="form.paperId" placeholder="请输入批次卷id" />
        </el-form-item>
        <el-form-item label="学生班级" prop="classId">
          <el-input v-model="form.classId" placeholder="请输入学生班级" />
        </el-form-item>
        <el-form-item label="考卷ID" prop="examineeId">
          <el-input v-model="form.examineeId" placeholder="请输入考卷ID" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Test_student">
import { listTest_student, getTest_student, delTest_student, addTest_student, updateTest_student } from "@/api/learn/test_student"

const { proxy } = getCurrentInstance()

const test_studentList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    batchId: null,
    studentId: null,
    directKey: null,
    paperId: null,
    classId: null,
    examineeId: null,
    status: null,
  },
  rules: {
    batchId: [
      { required: true, message: "批次id不能为空", trigger: "blur" }
    ],
    studentId: [
      { required: true, message: "学生id不能为空", trigger: "blur" }
    ],
    directKey: [
      { required: true, message: "定向标识学生可能有多个不能为空", trigger: "blur" }
    ],
    paperId: [
      { required: true, message: "批次卷id不能为空", trigger: "blur" }
    ],
    classId: [
      { required: true, message: "学生班级不能为空", trigger: "blur" }
    ],
    status: [
      { required: true, message: "状态不能为空", trigger: "change" }
    ],
    createTime: [
      { required: true, message: "发布时间不能为空", trigger: "blur" }
    ]
  }
})

const { queryParams, form, rules } = toRefs(data)

/** 查询测试学生列表 */
function getList() {
  loading.value = true
  listTest_student(queryParams.value).then(response => {
    test_studentList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    batchId: null,
    studentId: null,
    directKey: null,
    paperId: null,
    classId: null,
    examineeId: null,
    status: null,
    createTime: null
  }
  proxy.resetForm("test_studentRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加测试学生"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _id = row.id || ids.value
  getTest_student(_id).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改测试学生"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["test_studentRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateTest_student(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addTest_student(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value
  proxy.$modal.confirm('是否确认删除测试学生编号为"' + _ids + '"的数据项？').then(function() {
    return delTest_student(_ids)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => {})
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('learn/test_student/export', {
    ...queryParams.value
  }, `test_student_${new Date().getTime()}.xlsx`)
}

getList()
</script>
